export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);

        this.addInput("BearsPeriod", InputType.int, 13);
        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            BearsBuffer : this.addBuffer()
        };

        this.arr = {
            TempBuffer : [],
        };
    }

    onInit() {
        let {BearsPeriod} = this.getInputs();

        this.buffers.BearsBuffer
            .setShape(Shape.Histogram)
            .setColor(Color.Silver)
            .setLabel("Bears(" + BearsPeriod + ")")
            .setShortName("Bears(" + BearsPeriod + ")")
        ;
    }

    async onUpdate() {
        const  {BearsPeriod, PriceType} = this.getInputs(),
            {TempBuffer} = this.arr,
            {BearsBuffer} = this.buffers,
            {Low, Close} = await Bar.load([Bar.Mode.Low, Bar.Mode.Close], PriceType),
            barSize = Low.length;

        let i, countedBars = Bar.counted(), limit, list;

        if (barSize <= BearsPeriod) return 0;
        limit = barSize - countedBars;
        if (countedBars > 0) limit++;

        list = await Indicators.MA(null, 0, BearsPeriod, 0, Averaging.Exponential, AppliedPrice.Close, PriceType);
        for (i = 0; i < limit; i++) {
            TempBuffer[i] = list[i];
        }

        i = barSize - countedBars - 1;

        while (i >= 0) {
            BearsBuffer.set(i,  (Low[i] - TempBuffer[i]));
            i--;
        }
    }
}
